
function theta = transtat_sampparam(pp, nd, numsamp, ttype, tparam)
%transtat_sampparam     Sample from posterior parameter density for one class

switch ttype,
case 0,   % No transformations
  theta = zeros(1,numsamp);

case 1,   % Inverse-Wishart (constrained zero mean)
  dim = tparam(1);
  nu  = tparam(2) + nd;

  tranchol = reshape(pp(1:end-1), dim, dim);
  scale    = tranchol'*tranchol;

  theta  = zeros(dim^2,numsamp);
  for ii = 1:numsamp
    sigmaP = invwishart_rnd(scale, nu, 1);
    theta(:,ii) = sigmaP(:);
  end

case 2,   % Diagonal Inverse-Wishart (constrained zero mean)
  dim = tparam(1);
  nu  = tparam(2) + nd;

  tranchol = pp(1:dim);
  scale    = tranchol.^2;

  theta = zeros(dim,numsamp);
  for dd = 1:dim
    theta(dd,:) = invwishart_rnd(scale(dd), nu, numsamp);
  end

end

