
function data = getdata(OP,groups)
%getdata    Retrieve data for specified groups
%
%    data = getdata(OP, groups)
%
%  Return data points currently stored in objectpart instance OP, where
%    data{j} = cell array of data points in groups(j)

if nargin < 2
  groups = [1:OP.numgroup];
end

% data structures to store results
data = cell(length(groups),1);

% compute transformed mixtures, or tables, for each specified group
for j=1:length(groups)
  jj = groups(j);
  data{j} = OP.datass{jj};
end

