
%dictionaryKmeans    Build visual word dictionary from precomputed SIFT descriptors

clear all;

% Filename under which SIFT descriptors saved
featuresfilename = 'streetFixScale_2006_mser_ha_edges';
%featuresfilename = 'office_monocular_2006_mser_ha_edges';

% clustering parameters
numwords = 200;
kparam   = {'Display', 'iter', 'maxiter', 100, 'start', 'cluster'};

% load precomputed SIFT features
load(featuresfilename);

% Prepare features:
V = [imagedata.descriptor_left{:}];
C = [imagedata.classes{:}];
S = [imagedata.shapeROI_left{:}];
typeROI = [imagedata.typeROI_left{:}];

% set the distance matrix to 1 (not used)
dictionary.A = 1;

% Loop on types of ROI and create dictionaries for each type.
t = 1;
for t = 1:max(typeROI)
    m = find(typeROI == t);
    Vd = double(V(:,m));
    M = size(Vd,2); r = randperm(M);
    r = r(1:min(2000,M));
    Vd = Vd(:, r);

    % Project data
    A = dictionary.A;
    Vd = A*Vd;

    % run K-means clustering to build dictionary
    [ind, DICTvisualWords] = kmeans(Vd', numwords, kparam{:});

    % store data
    dictionary.clusters(:,:,t) = DICTvisualWords;
end

% store parameters:
dictionary.kparam = kparam;

% save dictionary
dictionaryfile = strcat(featuresfilename, '_dict');
save(dictionaryfile, 'dictionary');

