
%encodeWords    Map precomputed SIFT descriptors to dictionary of visual words

clear all;

% Filename under which SIFT descriptors saved
featuresfilename = 'streetFixScale_2006_mser_ha_edges';
%featuresfilename = 'office_monocular_2006_mser_ha_edges';

% encoding parameters
encodeShape = 1;

% load precomputed SIFT features
load(featuresfilename);

% load dictionary 
dictionaryfile = strcat(featuresfilename, '_dict');
load(dictionaryfile);

% Translate appearances into discrete words
Nimages = length(imagedata.files); numwords = 0;
for i = 1:Nimages
    i
    w = getWords(imagedata.descriptor_left{i}, imagedata.shapeROI_left{i}, imagedata.typeROI_left{i}, dictionary, encodeShape);
    imagedata.appearance{i} = w;
    numwords = max(numwords, max(w));
end

dictionary.numwords    = numwords;
dictionary.encodeShape = encodeShape;
imagedata.dictionary   = dictionary;

% save new data with the 'words' appended.
save(featuresfilename, 'imagedata');

% Show word counts
W = [imagedata.appearance{:}];
figure
hist(W, 1:numwords)
axis('tight')

