
%translate128x128    Scales and pads to make dataset of images that are 128x128

clear all
close all

targetSize = 128;

folderDatabase    = 'TODO';
newfolderDatabase = '../../database/imagesSharingIJCV';

folders = dir(folderDatabase);
Nfolders = length(folders);
for n = 3:Nfolders
    images = dir(fullfile(folderDatabase, folders(n).name, '*.jpg'));
    Nimages = length(images);
    
    mkdir(newfolderDatabase, folders(n).name);
    for i = 1:Nimages
        filename = fullfile(folderDatabase, folders(n).name, images(i).name);
        img = imread(filename);

        % Normalize image size
        [ncols nrows c] = size(img);
        img = mean(double(img),3);
        
        img = imresize(img, targetSize/max(ncols,nrows), 'bilinear', 21);
        [nrows ncols c] = size(img);
        
        img = padarray(img, [max(ceil((targetSize-nrows)/2),0) max(ceil((targetSize-ncols)/2),0)], 0, 'both');
        img = img(1:targetSize, 1:targetSize);
        img = img - min(img(:));
        img = img/max(img(:))*255;
        img = uint8(img);
        
        imshow(img); drawnow;
        
        % save image
        filename = fullfile(newfolderDatabase, folders(n).name, images(i).name);
        imwrite(img, filename, 'jpg', 'quality', 100)
    end
end

