
% Visualization of IJCV05 TDP scenes: feature segmentation performance

useStreet = 1;

if useStreet
  newlabel = 0;  % exclude unlabeled regions from test
  objstyle = {'r','m','b','g'};
  objindex = [1:4];

  trainfile = 'streetPartTDP_train2_10';
  testfile  = 'streetPartTDP_test10';
  testtrial = [1:100];
else
  newlabel = 4;  % assume unlabeled regions are background
  objstyle = {'r','b','g','k'};
  objindex = [1:4];

  trainfile = 'officePartTDP_train2_10';
  testfile  = 'officePartTDP_test10';
  testtrial = [1:100];
end

load(trainfile); load(testfile);

% plot parameters
axisROC  = [0 1 0 1];

% TDP performance
fullProb = zeros(length(objindex),0); testlabel = [];
testProb = testProb(:);
for kk = testgroup
  objlabel = imagedata.classes{kk};
  objlabel(find(objlabel==0)) = newlabel;

  testind   = find(objlabel > 0);
  testlabel = [testlabel objlabel(testind)];

  newprob = zeros(length(objindex),length(testind));
  for ii = testtrial
    newprob = newprob + testProb{ii}{kk}(objindex,testind);
  end
  newprob  = newprob / length(testtrial);
  fullProb = [fullProb newprob];
end
for oo = 1:length(objindex)
  [aROC(oo), alarmRate(oo,:), detectRate(oo,:)] = ...
    areaROC(fullProb(oo,:), (testlabel==objindex(oo)));
end

% plot ROC curves
Hfig = figure;
Hax = subplot(1,1,1,'Parent',Hfig); hold(Hax,'on');
for oo = 1:length(objindex)
  plot(Hax, alarmRate(oo,:), detectRate(oo,:), objstyle{oo}, 'linewidth', 3);
end
axis(Hax,'square'); axis(Hax, axisROC); grid(Hax,'on');

